% 4 mars 2020
% 6 mars 2020
% fusionner les roues
/gears {
50 dict begin
/ap 20 def
%/Z1 12 def
%/Z2 18 def
%/m1 0.2 def
%/thickness 1 def % paisseur des roues dentes
% /t@@x 0 def /t@@y 0 def
/a@ex m1 Z1 Z2 add mul 2 div def % entraxe engrenage exterieur
%/polarAngle 0 def
%/AngleRotation \i\space def
/Datas1 {
         /Z@ exch def
         /m@ exch def
         /R@ {m@ Z@ mul 2 div } bind def % cercle primitif
         /Rb {R@ ap cos mul } bind def % cercle de base
         /Rp {R@ 2 mul 2.5 m@ mul sub 2 div } bind def % cercle de pied
         /Rt {R@ 2 mul 2 m@ mul add 2 div } bind def % cercle de tte
         } def
/Calculs {
         % les valeurs suivantes sont en radians
         /ThetaP {R@ Rb div dup mul 1 sub sqrt } bind def % intersection avec cercle primitif
         /ThetaT {Rt Rb div dup mul 1 sub sqrt } bind def % intersection avec cercle de tete
         % Les valeurs suivantes ont en degrs
         /ThetaTdeg {Rt Rb div dup mul 1 sub sqrt rd} bind def %
         /ThetaPdeg {R@ Rb div dup mul 1 sub sqrt rd} bind def
         /DeltaP {ThetaPdeg sin ThetaP ThetaPdeg cos mul sub
                  ThetaPdeg cos ThetaP ThetaPdeg sin mul add
                  atan } bind def
         /DeltaT {ThetaTdeg sin ThetaT ThetaTdeg cos mul sub
                  ThetaTdeg cos ThetaT ThetaTdeg sin mul add
                  atan } bind def
         /DeltaS {Pi 2 div Z@ div } bind def
         /DeltaSdeg {90 Z@ div } bind def
         /AngleDent {360 Z@ div} bind def
         /ALPHA {DeltaSdeg DeltaP add DeltaT sub } bind def
         /2Beta {DeltaSdeg DeltaP add 2 mul } bind def
         /Beta_  {DeltaSdeg DeltaP add neg} bind def
          Rp Rb gt {/Rp Rb def} if
         /ptA {Rp 0} bind def
         /ptB {Rb 0} bind def
         /ptC {Rp DeltaSdeg 2 mul neg 2Beta 2 div add cos mul
               Rp DeltaSdeg 2 mul neg 2Beta 2 div add sin mul} bind def
         /ptA'{Rp DeltaP DeltaSdeg add 2 mul cos mul
               Rp DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptB'{Rb DeltaP DeltaSdeg add 2 mul cos mul
               Rb DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptC'{Rp DeltaSdeg 3 mul DeltaP add cos mul
               Rp DeltaSdeg 3 mul DeltaP add sin mul} bind def
         /Raxe {Rp 4 div } bind def
         /A@0 14.5 def % position et largeur de la clavette
% rayon de raccordement sur le cercle de pied
         /Rarct {Rp Pi mul Z@ div facteurRayonRaccord cm} bind def
         }
         def
% Le symetrique P' de P par rapport a la l'axe de la dent
% Delta(axe de la dent) y=x*tan(Beta)
% x'=y*sin(2*Beta)+x*cos(2*Beta)
% y'=x*sin(2*Beta)-y*cos(2*Beta)
% x y symAxe -> x' y'
/symAxe {
 2 dict begin
  /y exch def
  /x exch def
  y 2Beta sin mul x 2Beta cos mul add % x'
  x 2Beta sin mul y 2Beta cos mul sub % y'
 end
 }
 def
 %
% Rotation pour amener l'axe de la dent horizontal
%
/RotDent {
 2 dict begin
/y exch def
/x exch def
 i@ cos x mul i@ sin y mul sub
 i@ sin x mul i@ cos y mul add
end
} def
%
% developpante du cercle de base
 /devCercle {
  1 dict begin
  /t exch def % en degres
  Rb t cos t deg t sin mul add mul % x
  Rb t sin t deg t cos mul sub mul % y
 end
 }
 def
%
/Roue2D {
 % arc de dveloppante
/tabArcDev [
0 1 ThetaTdeg { /i@ exch def
 [i@ devCercle] } for
 ] def
 %
/n@ tabArcDev length def
/tabDent [
% l'arc de developpante initial
  tabArcDev aload pop
% l'arc ce cercle de tete
DeltaT 0.1 2Beta DeltaT sub {/i exch def
 [Rt i cos mul
  Rt i sin mul]
 } for
% le symetrique de l'arc de developpante par rapport a l'axe de la dent
n@ 1 sub -1 0  {
    /compteur exch def
    [tabArcDev compteur get aload pop symAxe]
    } for
    ] def
%%%
/n2@ tabDent length def
/ContourDent2D  [
ptC
0 1 Z@ 1 sub {/i@ exch AngleDent mul def
ptC RotDent
ptA RotDent
0 1 n2@ 1 sub {
    /compteur exch def
    tabDent compteur get aload pop
    RotDent
    } for
ptA' RotDent
ptC' RotDent
} for
] def
    0 thickness % hauteur =z1-z0
    0 0 1 % axe // Oz
  /u defpoint3d
   /z1 exch def
   /z0 exch def
   %% N = nb d etages
   /N ngrid 0 get def
   /table ContourDent2D def
   %% n = indice du dernier point
   /n  ContourDent2D length 2 idiv 1 sub def
   %% vecteur de translation
   u
   z1 z0 sub u norme3d div
   mulv3d /v defpoint3d
   %% tableau des sommets
   /S [
      0 1 N {
         /j exch def
         0 1 n {
             /i exch def
             table i getp
             z0
             v N j sub N div mulv addv3d
         } for
      } for
   ] def
   /F [
%% on supprime la face superieure
%%     [0 1 n {} for]  
%%   on conserve la base
      [N 1 add n 1 add mul 1 sub -1 N n 1 add mul {} for]
      %% faces etage
      1 1 N {
         /j exch def
         1 1 n {
             /i exch def
             [i                   j 1 sub n 1 add mul add
              i 1 sub             j 1 sub n 1 add mul add
              n 1 add i add 1 sub j 1 sub n 1 add mul add
              n 1 add i add       j 1 sub n 1 add mul add]
         } for
     } for
   ] def
   S F generesolid
   /Roue3D exch def
  ContourDent2D reversep
    /table exch def
   /n table length 2 idiv def
   /S table {0} papply def
   /F [
       [0 1 n 1 sub {} for]
   ] def
   S F generesolid
   /ContourSup exch def
   } def
%
m1 Z1 Datas1 Calculs
Roue2D
ContourSup /ContourSup1 exch def
Roue3D 
   dup {0 0 Beta_ AngleRotation sub rotateOpoint3d} solidtransform /ROUE1 exch def
m1 Z2 Datas1 Calculs
Roue2D 
Roue3D 
   dup {0 0 DeltaSdeg DeltaP add neg 180 Z2 div add 180 add Z1 Z2 div AngleRotation mul add polarAngle Z1 Z2 add Z2 div mul add rotateOpoint3d} solidtransform
   dup {a@ex polarAngle cos mul a@ex polarAngle sin mul 0 translatepoint3d} solidtransform
   /ROUE2 exch def
ROUE1 ROUE2 solidfuz 
gere_pstricks_opt
m1 Z1 Datas1 Calculs
Roue2D
ContourSup /ContourSup1 exch def
ContourSup1 
   dup {0 0 Beta_ AngleRotation sub rotateOpoint3d} solidtransform
   dup {0 0 thickness translatepoint3d} solidtransform
  dup {RotX RotY RotZ rotateOpoint3d} solidtransform
   dup {CX CY CZ translatepoint3d} solidtransform
   dup (fillincolor) outputcolors
/solidgrid true def
   drawsolid*
m1 Z2 Datas1 Calculs
Roue2D 
ContourSup /ContourSup2 exch def
ContourSup2
   dup {0 0 DeltaSdeg DeltaP add neg 180 Z2 div add 180 add Z1 Z2 div AngleRotation mul add polarAngle Z1 Z2 add Z2 div mul add rotateOpoint3d} solidtransform
%   dup {RotX RotY RotZ rotateOpoint3d} solidtransform
   dup {a@ex polarAngle cos mul a@ex polarAngle sin mul thickness translatepoint3d} solidtransform
   dup {RotX RotY RotZ rotateOpoint3d} solidtransform
   dup {CX CY CZ translatepoint3d} solidtransform
   dup (fillincolor) outputcolors
/solidgrid true def
   drawsolid** % gere_pstricks_opt
% les axes
     0 m1 Z1 mul 5 div 0.2
     [1 72]
      newcylindre
    dup {0 0 thickness translatepoint3d} solidtransform
    /solidgrid false def
    /fcol [0 (axiscolor)] def
    dup (fillincolor) outputcolors
    gere_pstricks_opt
     0 m1 Z2 mul 5 div 0.2
     [1 72]
      newcylindre
    dup {a@ex polarAngle cos mul a@ex polarAngle sin mul thickness translatepoint3d} solidtransform
    /solidgrid false def
    gere_pstricks_opt
end
  } def
%
/pst-gears {
   m1 Z1 Z2 thickness 
   gears
  }
  def
